// Experiment with STL map
#include <iostream>
#include <map>
#include <utility>  // to get pair class
#include <string>
#include <algorithm>
using namespace std;

int main () {
  map<string, int> myPhoneBook;
  map<string,int>::iterator mapIter1, mapIter2;
  
  string person;
  int phoneNumber;

  // Examples of assigning map container some content

  // 1) Assignment using array index notation
  myPhoneBook["Diesburg"] = 2737395;
  myPhoneBook["Schafer"] = 2732187;

  // 2) Assignment using member function insert() and STL pair
  person = "East";
  phoneNumber = 2732939;
  myPhoneBook.insert(pair<string, int>::pair(person,phoneNumber));
 
  // 3) Assignment using member function insert() and "value_type()"
  person = "Fienup";
  phoneNumber = 2735918;
  myPhoneBook.insert(map<string, int>::value_type(person,phoneNumber));
 
  myPhoneBook.insert(make_pair("Gray",2735917));
 
  cout << "myPhoneBook values: " << endl;
  // NOTE:  Interator are pointer to pair values with 
  // first attribute being the key and second being the value
  for (mapIter1 = myPhoneBook.begin(); mapIter1 != myPhoneBook.end(); mapIter1++) {
    cout << mapIter1->first << ":  " << mapIter1->second << endl;
  } // end for
  cout << endl << endl;

  cout << "Enter the name to look up a phone #: ";
  cin >> person;

  cout << person << ": " <<  myPhoneBook[person] << endl;

  return 0;
} // end main
