// Experiment with STL containers, iterators, and algorithms
#include <iostream>
#include <map>
#include <queue>
#include <vector>
#include <set>
#include <string>
#include <algorithm>
#include <cstdlib>
#include <ctime>
using namespace std;

int main () {
	map<int,string> monthsMap;
	map<int,string>::iterator monthIter1;
	map<string,int> monthsToNumberMap;
	map<string,int>::iterator monthIter2;
	vector<int> myVector;
	vector<int>::iterator left, right;
	set<int> mySet;
	set<int>::iterator setIter1, setIter2;
	string myMonth;
	unsigned startTime, endTime, seedValue;
	int count, numberOfElements;


	monthsMap[1] = myMonth.assign("January");
	monthsMap[2] = myMonth.assign("February");
	monthsMap[3] = myMonth.assign("March");
	monthsMap[4] = myMonth.assign("April");
	monthsMap[5] = myMonth.assign("May");
	monthsMap[6] = myMonth.assign("June");
	monthsMap[7] = myMonth.assign("July");
	monthsMap[8] = myMonth.assign("August");
	monthsMap[9] = myMonth.assign("September");
	monthsMap[10] = myMonth.assign("October");
	monthsMap[11] = myMonth.assign("November");
	monthsMap[12] = myMonth.assign("December");
 
	monthsToNumberMap[myMonth.assign("January")] = 1;
	monthsToNumberMap[myMonth.assign("February")] = 2;
	monthsToNumberMap[myMonth.assign("March")] = 3;
	monthsToNumberMap[myMonth.assign("April")] = 4;
	monthsToNumberMap[myMonth.assign("May")] = 5;
	monthsToNumberMap[myMonth.assign("June")] = 6;
	monthsToNumberMap[myMonth.assign("July")] = 7;
	monthsToNumberMap[myMonth.assign("August")] = 8;
	monthsToNumberMap[myMonth.assign("September")] = 9;
	monthsToNumberMap[myMonth.assign("October")] = 10;
	monthsToNumberMap[myMonth.assign("November")] = 11;
	monthsToNumberMap[myMonth.assign("December")] = 12;
 
	cout << "map month numbers to names values: " << endl;
	for (monthIter1 = monthsMap.begin(); monthIter1 != monthsMap.end(); monthIter1++) {
		cout << "key: " << monthIter1->first << "  value: " << monthIter1->second << endl;
	} // end for
	cout << endl << endl;

	cout << "map names to numbers values: " << endl;
	for (monthIter2 = monthsToNumberMap.begin(); monthIter2 != monthsToNumberMap.end(); monthIter2++) {
		cout << "key: " << monthIter2->first << "  value: " << monthIter2->second << endl;
	} // end for
	cout << endl << endl;

	cout << "Enter the number of elements to use: ";
	cin >> numberOfElements;

	seedValue = 10;
	srand(seedValue);

	startTime = static_cast<unsigned>(time(0));
	for (count = 0; count < numberOfElements; count++) {
		myVector.push_back(rand());
	} // end for
	endTime = static_cast<unsigned>(time(0));
	cout << "Vector fill time of " << numberOfElements << " elements using push_back took " 
		<< endTime - startTime << " seconds." << endl;	

	left = myVector.begin();
	startTime = static_cast<unsigned>(time(0));
	for (count = 0; count < numberOfElements; count++) {
		myVector.erase(left);
	} // end for
	endTime = static_cast<unsigned>(time(0));
	cout << "Vector erase time of " << numberOfElements << " elements using iterator at beginning took " 
		<< endTime - startTime << " seconds." << endl;	

	for (count = 0; count < numberOfElements; count++) {
		myVector.push_back(rand());
	} // end for

	startTime = static_cast<unsigned>(time(0));
	for (count = 0; count < numberOfElements; count++) {
		myVector.pop_back();
	} // end for
	endTime = static_cast<unsigned>(time(0));
	cout << "Vector erase time of " << numberOfElements << " elements using pop_back took " 
		<< endTime - startTime << " seconds." << endl;	

	// set some content in the vector:
	for (int i=0; i<10; i++) {
		int value = rand()%100;
		myVector.push_back(value);
		mySet.insert(value);
	} // end for

	cout << "vector values: ";
	for (left = myVector.begin(); left < myVector.end(); left++) {
		cout << *left << " ";
	} // end for
	cout << endl << endl;

	left = myVector.begin();
	right = myVector.end();
	left++;
	left++;
	right--;
	sort(left, right);

	cout << "vector values after sort: ";
	for (left = myVector.begin(); left < myVector.end(); left++) {
		cout << *left << " ";
	} // end for
	cout << endl;

	cout << "set values: ";
	for (setIter1 = mySet.begin(); setIter1 != mySet.end(); setIter1++) {
		cout << *setIter1 << " ";
	} // end for
	cout << endl << endl;

	// Cannot "sort" a set container
	//cout << endl << endl;
	//setIter1 = mySet.begin();
	//setIter2 = mySet.end();
	//sort(setIter1, setIter2);

	//cout << "set values after sort: ";
	//for (setIter1 = mySet.begin(); setIter1 != mySet.end(); setIter1++) {
	// cout << *setIter1 << " ";
	//} // end for

	priority_queue<int> mypq;

	int sum (0);

	for (int i=1;i<=10;i++) 
		mypq.push(i);


	while (!mypq.empty()) {
		sum += mypq.top();
		mypq.pop();
	}

	cout << "total: " << sum << endl;


	return 0;
} // end main